// File autogenerated

#if !defined(CONNECTION_H_INCLUDED)
#define CONNECTION_H_INCLUDED

// Qt D-Bus includes
#include <dbus/qdbusobject.h>

// forward declarations
class QDBusError;
class QDomElement;
class QString;
template <typename K> class QDBusDataMap;

namespace DBus
{

class Connection : public QDBusObjectBase
{
public:
    virtual ~Connection() {}

    static void buildIntrospectionData(QDomElement& interfaceElement);

protected: // implement sending signals
    virtual bool handleSignalSend(const QDBusMessage& reply) = 0;
    virtual QString objectPath() const = 0;

protected: // for sending D-Bus signals
    virtual bool emitUpdated(const QDBusDataMap<QString>& settings);

    virtual bool emitRemoved();


protected:
    virtual bool GetID(QString& id, QDBusError& error) = 0;

    virtual bool Update(const QDBusDataMap<QString>& properties, QDBusError& error) = 0;

    virtual bool Delete(QDBusError& error) = 0;

    virtual bool GetSettings(QDBusDataMap<QString>& settings, QDBusError& error) = 0;

protected: // implement sending replies
    virtual void handleMethodReply(const QDBusMessage& reply) = 0;

protected: // usually no need to reimplement
    virtual bool handleMethodCall(const QDBusMessage& message);

    QDBusMessage callGetID(const QDBusMessage& message);

    QDBusMessage callUpdate(const QDBusMessage& message);

    QDBusMessage callDelete(const QDBusMessage& message);

    QDBusMessage callGetSettings(const QDBusMessage& message);

}; // class Connection

}; // namespace DBus

// Qt includes
#include <qmap.h>

// Qt D-Bus includes
#include <dbus/qdbusmessage.h>
#include <dbus/qdbusobject.h>

// forward declarations
class QDBusError;
class QDomElement;
class QString;
class QStringList;
template <typename K> class QDBusDataMap;

namespace DBus
{

class Secrets : public QDBusObjectBase
{
public:
    virtual ~Secrets() {}

    static void buildIntrospectionData(QDomElement& interfaceElement);

public:
    virtual void GetSecretsAsyncReply(int asyncCallId, const QDBusDataMap<QString>& secrets);

    virtual void GetSecretsAsyncError(int asyncCallId, const QDBusError& error);

protected:
    virtual void GetSecretsAsync(int asyncCallId, const QString& setting_name, const QStringList& hints, bool request_new) = 0;

protected: // implement sending replies
    virtual void handleMethodReply(const QDBusMessage& reply) = 0;

protected: // usually no need to reimplement
    virtual bool handleMethodCall(const QDBusMessage& message);

    void callGetSecretsAsync(const QDBusMessage& message);

protected:
    QMap<int, QDBusMessage> m_asyncCalls;

}; // class Secrets

}; // namespace DBus

#endif //CONNECTION_H_INCLUDED

// End of File

