// File autogenerated

#if !defined(NETWORKMANAGERPROXY_H_INCLUDED)
#define NETWORKMANAGERPROXY_H_INCLUDED

// Qt includes
#include <qmap.h>
#include <qobject.h>

// forward declarations
class QDBusConnection;
class QDBusDataList;
class QDBusError;
class QDBusMessage;
class QDBusObjectPath;
class QDBusProxy;
class QDBusVariant;
class QString;
template <typename T> class QValueList;

namespace DBus
{

class NetworkManagerProxy : public QObject
{
    Q_OBJECT
public:
    NetworkManagerProxy(const QString& service, const QString& path, QObject* parent = 0, const char* name = 0);

    virtual ~NetworkManagerProxy();

    void setConnection(const QDBusConnection& connection);

signals:
    void StateChanged(Q_UINT32 state);

    void PropertiesChanged(const QMap<QString, QDBusVariant>& properties);

    void DeviceAdded(const QDBusObjectPath& device_path);

    void DeviceRemoved(const QDBusObjectPath& device_path);

    void StateChange(Q_UINT32 state);

    void ActivateConnectionAsyncReply(int asyncCallId, const QDBusObjectPath& active_connection);


public:
    virtual bool GetDevices(QValueList<QDBusObjectPath>& devices, QDBusError& error);

    virtual bool DeactivateConnection(const QDBusObjectPath& active_connection, QDBusError& error);

    virtual bool Sleep(bool sleep, QDBusError& error);

    virtual bool sleep(QDBusError& error);

    virtual bool wake(QDBusError& error);

    virtual bool state(Q_UINT32& state, QDBusError& error);

    virtual bool ActivateConnectionAsync(int& asyncCallId, const QString& service_name, const QDBusObjectPath& connection, const QDBusObjectPath& device, const QDBusObjectPath& specific_object, QDBusError& error);

public:
    virtual void setDBusProperty(const QString& name, const QDBusVariant& variant, QDBusError& error);
    virtual QDBusVariant getDBusProperty(const QString& name, QDBusError& error) const;

    virtual void setWirelessEnabled(bool value, QDBusError& error);
    virtual bool getWirelessEnabled(QDBusError& error) const;

    virtual bool getWirelessHardwareEnabled(QDBusError& error) const;

    virtual QValueList<QDBusObjectPath> getActiveConnections(QDBusError& error) const;

    virtual Q_UINT32 getState(QDBusError& error) const;

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const QDBusMessage& message);

    virtual void slotHandleAsyncReply(int id, const QDBusMessage& message);

protected:
    QDBusProxy* m_baseProxy;

    QMap<int, QString> m_asyncCalls;

private: // Hiding copy constructor and assignment operator
    NetworkManagerProxy(const NetworkManagerProxy&);
    NetworkManagerProxy& operator=(const NetworkManagerProxy&);
}; // class NetworkManagerProxy

}; // namespace DBus

#endif //NETWORKMANAGERPROXY_H_INCLUDED

// End of File

