// File autogenerated

// declaration include
#include "networkmanagersettings.h"

// Qt includes
#include <qdom.h>
#include <qvaluelist.h>

// Qt D-Bus includes
#include <dbus/qdbusdatalist.h>
#include <dbus/qdbuserror.h>
#include <dbus/qdbusmessage.h>
#include <dbus/qdbusobjectpath.h>


namespace DBus
{

void SettingsInterface::buildIntrospectionData(QDomElement& interfaceElement)
{
    interfaceElement.setAttribute("name", "org.freedesktop.NetworkManagerSettings");

    QDomDocument document = interfaceElement.ownerDocument();
    QDomElement methodElement = document.createElement("method");
    methodElement.setAttribute("name", "ListConnections");

    QDomElement argumentElement = document.createElement("arg");
    argumentElement.setAttribute("name",      "connections");
    argumentElement.setAttribute("type",      "ao");
    argumentElement.setAttribute("direction", "out");
    methodElement.appendChild(argumentElement);

    interfaceElement.appendChild(methodElement);

    methodElement = document.createElement("signal");
    methodElement.setAttribute("name", "NewConnection");

    argumentElement = document.createElement("arg");
    argumentElement.setAttribute("name",      "connection");
    argumentElement.setAttribute("type",      "o");
    argumentElement.setAttribute("direction", "in");
    methodElement.appendChild(argumentElement);

    interfaceElement.appendChild(methodElement);
}

bool SettingsInterface::emitNewConnection(const QDBusObjectPath& connection)
{
    QString path = objectPath();
    Q_ASSERT(!path.isEmpty());

    QDBusMessage message = QDBusMessage::signal(path, "org.freedesktop.NetworkManagerSettings", "NewConnection");

    message << QDBusData::fromObjectPath(connection);

    return handleSignalSend(message);
}


QDBusMessage SettingsInterface::callListConnections(const QDBusMessage& message)
{
    QDBusError   error;
    QDBusMessage reply;

    QValueList<QDBusObjectPath> _connections;

    if (ListConnections(_connections, error))
    {
        reply = QDBusMessage::methodReply(message);
        reply << QDBusData::fromList(QDBusDataList(_connections));
    }
    else
    {
        if (!error.isValid())
        {
            qWarning("Call to implementation of DBus::SettingsInterface::ListConnections returned 'false' but error object is not valid!");

            error = QDBusError::stdFailed("DBus.SettingsInterface.ListConnections execution failed");
        }

        reply = QDBusMessage::methodError(message, error);
    }

    return reply;
}

bool SettingsInterface::handleMethodCall(const QDBusMessage& message)
{
    if (message.interface() != "org.freedesktop.NetworkManagerSettings") return false;

    if (message.member() == "ListConnections")
    {
        QDBusMessage reply = callListConnections(message);
        handleMethodReply(reply);

        return true;
    }

    return false; 
}

}; // namespace DBus

// End of File

