// File autogenerated

#if !defined(WIRELESSPROXY_H_INCLUDED)
#define WIRELESSPROXY_H_INCLUDED

// Qt includes
#include <qobject.h>

// forward declarations
class QDBusConnection;
class QDBusDataList;
class QDBusError;
class QDBusMessage;
class QDBusObjectPath;
class QDBusProxy;
class QDBusVariant;
class QString;
template <typename K, typename V> class QMap;
template <typename T> class QValueList;

namespace DBus
{

class WirelessDeviceProxy : public QObject
{
    Q_OBJECT
public:
    WirelessDeviceProxy(const QString& service, const QString& path, QObject* parent = 0, const char* name = 0);

    virtual ~WirelessDeviceProxy();

    void setConnection(const QDBusConnection& connection);

signals:
    void PropertiesChanged(const QMap<QString, QDBusVariant>& properties);

    void AccessPointAdded(const QDBusObjectPath& access_point);

    void AccessPointRemoved(const QDBusObjectPath& access_point);


public:
    virtual bool GetAccessPoints(QValueList<QDBusObjectPath>& access_points, QDBusError& error);

public:
    virtual void setDBusProperty(const QString& name, const QDBusVariant& variant, QDBusError& error);
    virtual QDBusVariant getDBusProperty(const QString& name, QDBusError& error) const;

    virtual QString getHwAddress(QDBusError& error) const;

    virtual Q_UINT32 getMode(QDBusError& error) const;

    virtual Q_UINT32 getBitrate(QDBusError& error) const;

    virtual QDBusObjectPath getActiveAccessPoint(QDBusError& error) const;

    virtual Q_UINT32 getWirelessCapabilities(QDBusError& error) const;

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const QDBusMessage& message);

protected:
    QDBusProxy* m_baseProxy;

private: // Hiding copy constructor and assignment operator
    WirelessDeviceProxy(const WirelessDeviceProxy&);
    WirelessDeviceProxy& operator=(const WirelessDeviceProxy&);
}; // class WirelessDeviceProxy

}; // namespace DBus

#endif //WIRELESSPROXY_H_INCLUDED

// End of File

